precision mediump float;
varying vec2 interp_tc;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;
uniform float bitDepth;
uniform mat3 mColorConversion;
void main() {
    vec3 yuv;
    if(bitDepth==2.0){
        vec3 yuv_l;
        vec3 yuv_h;
        yuv_l.x = texture2D(y_tex, interp_tc).r;
        yuv_h.x = texture2D(y_tex, interp_tc).a;
        yuv_l.y = texture2D(u_tex, interp_tc).r;
        yuv_h.y = texture2D(u_tex, interp_tc).a;
        yuv_l.z = texture2D(v_tex, interp_tc).r;
        yuv_h.z = texture2D(v_tex, interp_tc).a;
        yuv = (yuv_l * 255.0 + yuv_h * 255.0 * 256.0) / (1023.0) - vec3(16.0 / 255.0, 0.5, 0.5);
    }else{
        yuv.x = texture2D(y_tex, interp_tc).r - 0.0625;
        yuv.y = texture2D(u_tex, interp_tc).r - 0.5;
        yuv.z = texture2D(v_tex, interp_tc).r - 0.5;
    }
    gl_FragColor = vec4(mColorConversion * yuv, 1.0);

}